(**
 * Copyright (c) 2015, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the "hack" directory of this source tree.
 *
 *)

type t = GlobalOptions.t [@@deriving show]
let safe_array = GlobalOptions.tco_safe_array
let safe_vector_array = GlobalOptions.tco_safe_vector_array
let disallow_ambiguous_lambda = GlobalOptions.tco_disallow_ambiguous_lambda
let disallow_array_typehint = GlobalOptions.tco_disallow_array_typehint
let disallow_array_literal = GlobalOptions.tco_disallow_array_literal
let language_feature_logging = GlobalOptions.tco_language_feature_logging
let unsafe_rx = GlobalOptions.tco_unsafe_rx
let experimental_feature_enabled =
  GlobalOptions.tco_experimental_feature_enabled
let migration_flag_enabled =
  GlobalOptions.tco_migration_flag_enabled
let log_inference_constraints = GlobalOptions.tco_log_inference_constraints
let default = GlobalOptions.default
let experimental_instanceof = GlobalOptions.tco_experimental_instanceof
let experimental_isarray = GlobalOptions.tco_experimental_isarray
let experimental_goto = GlobalOptions.tco_experimental_goto
let experimental_disable_shape_and_tuple_arrays =
  GlobalOptions.tco_experimental_disable_shape_and_tuple_arrays
let experimental_stronger_shape_idx_ret =
  GlobalOptions.tco_experimental_stronger_shape_idx_ret
let experimental_annotate_function_calls =
  GlobalOptions.tco_experimental_annotate_function_calls
let experimental_unresolved_fix =
  GlobalOptions.tco_experimental_unresolved_fix
let experimental_generics_arity =
  GlobalOptions.tco_experimental_generics_arity
let experimental_forbid_nullable_cast =
  GlobalOptions.tco_experimental_forbid_nullable_cast
let experimental_coroutines =
  GlobalOptions.tco_experimental_coroutines
let experimental_disallow_static_memoized =
  GlobalOptions.tco_experimental_disallow_static_memoized
let experimental_no_trait_reuse = GlobalOptions.tco_experimental_no_trait_reuse
let experimental_reified_generics =
  GlobalOptions.tco_experimental_reified_generics
let experimental_type_param_shadowing =
  GlobalOptions.tco_experimental_type_param_shadowing
let experimental_trait_method_redeclarations =
  GlobalOptions.tco_experimental_trait_method_redeclarations
let experimental_type_const_attributes =
  GlobalOptions.tco_experimental_type_const_attributes
let experimental_abstract_type_const_with_default =
  GlobalOptions.tco_experimental_abstract_type_const_with_default

let experimental_decl_linearization =
  GlobalOptions.tco_experimental_decl_linearization
let experimental_track_subtype_prop =
  GlobalOptions.tco_experimental_track_subtype_prop
let experimental_all = GlobalOptions.tco_experimental_all
let migration_flags_all = GlobalOptions.tco_migration_flags_all
let dynamic_view = GlobalOptions.tco_dynamic_view
let disallow_array_as_tuple = GlobalOptions.tco_disallow_array_as_tuple
let disallow_implicit_returns_in_non_void_functions =
  GlobalOptions.tco_disallow_implicit_returns_in_non_void_functions
let disallow_unset_on_varray = GlobalOptions.tco_disallow_unset_on_varray
let disallow_scrutinee_case_value_type_mismatch =
  GlobalOptions.tco_disallow_scrutinee_case_value_type_mismatch
let disallow_stringish_magic = GlobalOptions.tco_disallow_stringish_magic
let new_inference_lambda = GlobalOptions.tco_new_inference_lambda
let timeout = GlobalOptions.tco_timeout
let disallow_invalid_arraykey = GlobalOptions.tco_disallow_invalid_arraykey
let disable_instanceof_refinement = GlobalOptions.tco_disable_instanceof_refinement
let disallow_byref_dynamic_calls = GlobalOptions.tco_disallow_byref_dynamic_calls
let log_levels = GlobalOptions.log_levels
let typecheck_xhp_cvars = GlobalOptions.tco_typecheck_xhp_cvars
let ignore_collection_expr_type_arguments = GlobalOptions.tco_ignore_collection_expr_type_arguments
let shallow_class_decl = GlobalOptions.tco_shallow_class_decl
let like_types = GlobalOptions.tco_like_types
let pessimize_types = GlobalOptions.tco_pessimize_types

let check_xhp_attribute = GlobalOptions.tco_check_xhp_attribute
