#![feature(box_patterns)]
// Copyright (c) 2019, Facebook, Inc.
// All rights reserved.
//
// This source code is licensed under the MIT license found in the
// LICENSE file in the "hack" directory of this source tree.

pub mod token_kind;
pub mod trivia_kind;

pub mod source_text;

pub mod lexable_token;
pub mod lexable_trivia;

pub mod syntax;
mod syntax_generated;
pub mod syntax_kind;
mod syntax_type;

pub mod syntax_error;

pub mod lexer;
pub mod operator;
mod operator_generated;
pub mod parser;
pub mod parser_env;

pub mod coroutine_smart_constructors;
mod coroutine_smart_constructors_generated;
pub mod decl_mode_smart_constructors;
mod decl_mode_smart_constructors_generated;
pub mod flatten_smart_constructors;

#[macro_use]
pub mod smart_constructors; // must be before users of providing macros (*_parser)
mod smart_constructors_generated;
pub mod smart_constructors_wrappers;
pub mod syntax_smart_constructors;

pub mod parser_trait;

pub mod declaration_parser;
pub mod expression_parser;
pub mod statement_parser;
pub mod type_parser;

pub mod minimal_parser;
mod minimal_smart_constructors;
pub mod minimal_syntax;
pub mod minimal_token;
pub mod minimal_trivia;

pub mod file_mode;

pub mod positioned_smart_constructors;
pub mod positioned_syntax;
pub mod positioned_token;
pub mod positioned_trivia;
